#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct
{
    unsigned day, month, year;
}date;
typedef struct
{
    char name[51],sname[51];
    date birth;
    unsigned phone;
}contact;

contact getContactData(contact where);
contact find(contact db[],int count, char *name);
void displayContact(contact person);
void displayContacts(contact db[], int count);
void removeNL(char *string);

int main()
{
    contact database[50];
    int count = 0;
    do
    {
        database[count]=getContactData(database[count]);

    }while(strlen(database[count].name)>0 && count++<50);

    printf("Zadane kontakty:\n");
    displayContacts(database,count);
    printf("Jmeno hledane osoby:");
    char name[51];
    fgets(name,50,stdin);
    removeNL(name);
    contact found = find(database,count,name);
    if(strlen(found.name)>0)displayContact(found);
    else printf("Kontakt se jmenem %s nenalezen.\n",name);
    return 0;
}

void removeNL(char *where)
{
    char *nl = strchr(where,'\n');
    if(nl!=NULL)
    {
        *nl='\0';
    }
    else while(getchar()!='\n');
}
contact getContactData(contact where)
{
    printf("Jmeno:");
    fgets(where.name,50,stdin);
    removeNL(where.name);
    if(strlen(where.name)==0)return where;
    printf("Prijmeni:");
    fgets(where.sname,50,stdin);
    removeNL(where.sname);
    printf("Datum narozeni (dd-mm-rrrr):");
    scanf("%2u-%2u-%4u",&where.birth.day,&where.birth.month,&where.birth.year);
    printf("Telefon:");
    scanf("%u",&where.phone);
    getchar();
    return where;
}

void displayContact(contact person)
{
    printf("Jmeno:%s %s\n",person.name,person.sname);
    printf("Datum narozeni: %u.%u. %u\n",person.birth.day,person.birth.month,person.birth.year);
    printf("Telefon: %u\n",person.phone);
}
contact find(contact db[],int count, char *name)
{
    int i;
    contact *cont = (contact*)malloc(sizeof(contact));
    strcpy(cont->name,"");
    for(i=0;i<count && strcmp(db[i].name,name)!=0;i++);
    if(!strcmp(db[i].name,name))return db[i];
    else return *cont;
}
void displayContacts(contact db[], int count)
{
    for(int i=0;i<count;i++)
    {
        displayContact(db[i]);
    }
}
